//Written by David_G
#include <Servo.h>

Servo servo_pan;
Servo servo_tilt;
float pan,tilt;
float ppan,ptilt;  
float upper,lower;

//init the servo to ports & position
void MyServo(int pan_port, int tilt_port) {
    servo_pan.attach(pan_port);
    servo_tilt.attach(tilt_port);
    pan=tilt=90;
    ppan=ptilt=0;
    upper = 145;
    lower = 35;
    servo_move(); //set up the initial move/position
};
  
//call comand to move servos to a specific position
void servo_move() {    
  if(ppan != pan) {
    servo_pan.write(pan);
    delay(100*abs(ppan-pan)/80); //calculate a delay for the move
    ppan = pan;   
    Serial.print("AP"); 
    Serial.print(pan);
    Serial.print(';');
  }
  if(ptilt != tilt) {
    servo_tilt.write(tilt);
    delay(100*abs(ptilt-tilt)/80);
    ptilt = tilt;    
    Serial.print("AT"); 
    Serial.print(tilt);
    Serial.print(';');
  }
};
  
//main routine, command parses string and issues serial movement
//only call with one command sequence -- pan XOR tilt
boolean servo_command(char *cmd) {
  char c=cmd[0];
  float v=parse_float(cmd, 1);
  //expecting at most 3 digits, convert the value into an int
  //this was needed since atoi was messing up and this seems more stable and faster
  if(c == 'u') upper = v;
  else if(c == 'l') lower = v;
  else if(v <= upper && v >= lower) {        
    if(c == 'p') pan=v;
    else if(c = 't') tilt=v;
  }
  else {
    if(c == 'u' || c == 'l' || c == 'p' || c == 't') {
      Serial.print("OB");
      Serial.print(v);
      Serial.print(" <= ");
      Serial.print(cmd);
    }
    return false;
  }
  servo_move();
  return true; //proprly parsed command
};

float parse_float(char *num, int pos) {
   int i=pos;
   float v=0;
   while(num[i] != ';' && num[i] != '.') {
     v*=10; v += (num[i]-48);
     i++;
   } 
   if(num[i] != ';') v += parse_fpart(num, i+1);
   return v;   
}
float parse_fpart(char *num, int pos) {
   int i=pos;
   float v=0;
   float f=10.0;
   while(num[i] != ';') {
     v += (num[i]-48)/f;
     f*=10;
     i++;
   } 
   return v;
}

